/***************************************************************************
                          List.h  -  description
                             -------------------
    begin                : Tue Feb 27 2001
    copyright            : (C) 2001 by kulich
    email                : xrotek@fi.muni.cz
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

///// operator[] indexuje od 0!!!!!!!!!!!!!!!

#include <iostream>

#ifndef __LIST_H__
#define __LIST_H__

template<class T>

class List {

  private:

    struct Item {
      Item * next;
      T value;
    };

    Item * first;
    Item * current;
    Item * last;
    long card; // kardinalita

  public:

    List();
    ~List();
    void AddFirst(T element);
    void AddLast(T element);
	  void Remove(T element);
    void RemoveFirst();
    void RemoveLast();
    void RemoveCurrent();
	  void RemoveAll();
    void MoveLeft();
    void MoveRight();
    void MoveFirst();
    void MoveLast();
    void Write();
    bool SetCurrent(T);
	void SetCurrent(Item * ptr) { current=ptr; };
    	 	
	  T & GetAdrFirstItem() { return first->value; };
		T & GetAdrLastItem() { return last->value; };
		T & GetAdrCurrentItem() { return current->value; };
    T GetFirstItem();
    T GetLastItem();
    T GetCurrentItem();	
    Item * GetFirst() { return first; };
    Item * GetCurrent() { return current; };
    Item * GetLast() { return last; };
    T & operator[](long);

    int IsEmpty();
    int Member(T);
    int Find(T);
	  int FindP(T);

    long NoOfItems();
    long GetCard();

};

//////////////////////////////////////////////////////////////////////

template<class T> List<T>::List() {

  first=0;
  current=0;
  last=0;
  card=0;

};

//////////////////////////////////////////////////////////////////////

template<class T> List<T>::~List() {

	RemoveAll();

};                                           

//////////////////////////////////////////////////////////////////////

template<class T> void List<T>::RemoveAll() {

  while (IsEmpty()==0) {
    RemoveFirst();
  };

};


template<class T> void List<T>::AddFirst(T element) {
  
  Item * new_item=new Item;

  new_item->value=element;
  new_item->next=first;
  first=new_item;
  current=new_item;
  if (last==0) last=new_item;
  card++;

};

//////////////////////////////////////////////////////////////////////

template<class T> void List<T>::AddLast(T element) {
 
  Item * new_item=new Item;

  new_item->value =element;
  new_item->next=0;
  current=new_item;
  if (last!=0) last->next=new_item;
  last=new_item;
  if (first==0) first=new_item;
  card++;

};

//////////////////////////////////////////////////////////////////////

template<class T> bool List<T>::SetCurrent(T element) {

	current=first;
	
  while (!(current==0||current->value==element)) current=current->next;
  if (current==0) return(0); return(1);

};

//////////////////////////////////////////////////////////////////////

template<class T> void List<T>::RemoveFirst() {

  Item * tmp_item=first;
 
  if (tmp_item!=0) {
    if (tmp_item==last) { 
      current=0;
      last=0; }
    else 
      if (current==first) current=tmp_item->next;
    first=first->next;
    delete(tmp_item);
    card--;
  };

};

//////////////////////////////////////////////////////////////////////

template<class T> void List<T>::RemoveLast() {

  Item * tmp_last=last;
  Item * tmp=first;

  if (tmp_last!=0) {
    if (first==last) { 
      current=0; 
      first=0; 
      last=0; }
    else { 
      while (tmp->next!=last) tmp=tmp->next;
      if (current==last) current=tmp;
      last=tmp;
      last->next=0;
    };
    delete(tmp_last);
    card--;
  };

};

//////////////////////////////////////////////////////////////////////

template<class T> void List<T>::RemoveCurrent() {

  Item * tmp_current=current;
  Item * tmp=first;

  if ((current==first)&&(current!=0)) RemoveFirst();
  else
    if (current==last) RemoveLast();
    else {
      while (tmp->next!=current) tmp=tmp->next;
      tmp->next=current->next;
      current=current->next;
      delete(tmp_current);
      card--;
    };

};

//////////////////////////////////////////////////////////////////////

template<class T> void List<T>::MoveLeft() {

  Item * tmp=first;

  if (tmp!=0) {
    while (tmp->next!=current) tmp=tmp->next;
    current=tmp;
  };

};

//////////////////////////////////////////////////////////////////////

template<class T> void List<T>::MoveRight() {

	if (current!=last) current=current->next;
	
};

//////////////////////////////////////////////////////////////////////

template<class T> void List<T>::MoveFirst() {

  current=first;

};

//////////////////////////////////////////////////////////////////////

template<class T> void List<T>::MoveLast() {

  current=last;

};

//////////////////////////////////////////////////////////////////////

template<class T> T List<T>::GetFirstItem() {

  return first->value;

};

//////////////////////////////////////////////////////////////////////

template<class T> T List<T>::GetCurrentItem() {

  return current->value;

};

//////////////////////////////////////////////////////////////////////

template<class T> T List<T>::GetLastItem() {

  return last->value;

};

//////////////////////////////////////////////////////////////////////

template<class T> void List<T>::Write() {

  Item * tmp=first;
  while (tmp!=0) {
	  std::cout<<tmp->value;
    tmp=tmp->next;
  };

};

//////////////////////////////////////////////////////////////////////

template<class T> T & List<T>::operator[](long index) {

  Item * tmp=first;

  if (index>=0&&index<=card) {
    while (index!=0) {
      tmp=tmp->next;
      index--;
    };
  };
  return tmp->value;

};

//////////////////////////////////////////////////////////////////////

template<class T> int List<T>::IsEmpty() {
 
  if (card==0) return 1; return 0;

};

//////////////////////////////////////////////////////////////////////

template<class T> int List<T>::Member(T element) {

  Item * tmp=first;
  
  while (!(tmp==0||tmp->value==element)) tmp=tmp->next;
  if (tmp!=0) {
    return(1);
  }
  else {
    return(0);
  };

};

/////////////////////////////////////////////////////////////////////

template<class T> int List<T>::Find(T element) {

  Item * tmp=first;
  int i=0;

  while (!(tmp==0||tmp->value==element)) {
    tmp=tmp->next;
    i++;
  };
  if (tmp!=0) 
	  return i; 
  
  return -1;

};


template<class T> int List<T>::FindP(T element) {

  Item * tmp=first;
  int i=0;

  while (!(tmp==0||*(tmp->value)==(*element))) {
    tmp=tmp->next;
    i++;
  };
  if (tmp!=0) 
	  return i; 
  
  return -1;

};

/////////////////////////////////////////////////////////////////////

template<class T> long List<T>::NoOfItems() {
  
  long count=0;
  Item * tmp=first;
  while (tmp!=0) {
    tmp=tmp->next;
    count++;
  };
  return count;

};

/////////////////////////////////////////////////////////////////////

template<class T> long List<T>::GetCard() {

  return card;

};

/////////////////////////////////////////////////////////////////////

#endif.. 