/***************************************************************************
                          MiniMax.cpp  -  description
                             -------------------
    begin                : Tue Feb 27 2001
    copyright            : (C) 2001 by kulich
    email                : xrotek@fi.muni.cz
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "minimax.h"

PointToReturn::PointToReturn() {

};

PointToReturn::PointToReturn(int pos, int val){

	position = pos;
	value = val;

};


PointToReturn::~PointToReturn() {

};

MinMax::MinMax() {
};

// vraci nejlepsi tah a jako parametr vraci hodnotu nejlepsiho tahu

bool MinMax::DetectCycles(int player, int point, Board & returned_board) {

// list predstavuje seznam bodu v primem okoli daneho bodu, mezi nimiz 
// hledame cestu
	
	List<int> list;
	int found_position=0;
	bool founded=false;
	int direction=0;
	bool flags[9]={false,false,false,false,false,false,false,false};
	
	for (int i=-1; i<=1; i++) 
		for (int j=-1; j<=1; j++) {
			if ((((point % WIDTH) + i)>=0) &&
			(((point % WIDTH) + i)<=WIDTH-1) &&
			(((point / WIDTH)+ j)>=0) &&
			(((point / WIDTH)+ j)<=HEIGHT-1)) {				
				if (player==0) {
					flags[direction]=PlayBoard[point+i+j*WIDTH]<0?true:false;
				}
				else {
					flags[direction]=PlayBoard[point+i+j*WIDTH]>0?true:false;
				};		
			};
			direction++;
		};
		
// nejprve vytvorime seznam vsech bodu kolem point, ktere patri danemu hraci
// v tomto seznamu by se zatim vyskytuji i sousedni policka, coz ma za
// dusledek, ze se detekuje i cyklus delky 3 = trojuhelnik
// vyresi se to tak, ze se bude brat v potaz nejblizsi mozny ob-soused
// vyreseno pomoci case....

		if (flags[0]||flags[1]||flags[3]) {
			if (flags[0]) {
				returned_board[point-1-WIDTH]=10;
				list.AddFirst(point-1-WIDTH);
			}
			else if (flags[1]) {
					returned_board[point-1]=11;
					list.AddFirst(point-1);
			}
			else {
				returned_board[point-WIDTH]=13;
				list.AddFirst(point-WIDTH);
			};
		};


		if (flags[5]||flags[7]||flags[8]) {
			if (flags[5]&&!flags[1]&&!flags[7]) {
				returned_board[point+WIDTH]=15;
				list.AddFirst(point+WIDTH);
			}
			else if (flags[7]&&!flags[3]&&!flags[5]) {
					returned_board[point+1]=17;
					list.AddFirst(point+1);
			}
			else if (!flags[5]&&!flags[7]) {
				returned_board[point+1+WIDTH]=18;
				list.AddFirst(point+1+WIDTH);
			};
		};


		if (flags[2]&&!flags[1]&&!flags[5]) {
			returned_board[point-1+WIDTH]=12;
			list.AddFirst(point-1+WIDTH);
		};

		if (flags[6]&&!flags[3]&&!flags[7]) {
			returned_board[point+1-WIDTH]=16;
			list.AddFirst(point+1-WIDTH);
		};
// nyni rozexpandujeme nalezene body pomoci DFS
// mozne vylepseni, pri dosazeni hranice cestu, ktera narazila
// vyradit ze seznamu pokracovani. Tim zajistim minimalizaci
// oblasti a take nejkratsi cyklus

		int f_list; //first item in list

		while (!list.IsEmpty()) {
			f_list=list.GetFirstItem();
			list.RemoveFirst();

			for (int i=-1; i<=1; i++) 
				for (int j=-1; j<=1; j++) {
					if ((((f_list % WIDTH) + i)>=0) &&
					(((f_list % WIDTH) + i)<=WIDTH-1) &&
					(((f_list / WIDTH)+ j)>=0) &&
					(((f_list / WIDTH)+ j)<=HEIGHT-1)) {
						found_position=f_list+i+j*WIDTH;
						if (player==0 
							&& PlayBoard[found_position]<0) {
							if (returned_board[found_position]==0) {
								returned_board[found_position]=returned_board[f_list]+10;
								list.AddLast(found_position);
							}
							else {
								if ((returned_board[found_position]
									-returned_board[f_list]) % 10 != 0)
									founded=true;	     
							};
						};
						if (player==1 
							&& PlayBoard[found_position]>0) {
							if (returned_board[found_position]==0) {
								returned_board[found_position]=returned_board[f_list]+10;
								list.AddLast(found_position);
							}
							else {
								if ((returned_board[found_position]
									-returned_board[f_list]) % 10 != 0)
									founded=true;	     
							};
						};
					};
				};

		}; // end_while

	return(founded);
};

void MinMax::ExpandSeed(Board & tmp_board, Board & returned_board, int seed_position) {

	List<int> path;
	int item;
	
	if (tmp_board[seed_position]==0) {
		if(returned_board[seed_position]<=0) {
			tmp_board[seed_position]=-1;
			path.AddLast(seed_position);
				while (!path.IsEmpty()) {
				item = path.GetFirstItem();
				path.RemoveFirst();
				if (item%WIDTH!=WIDTH-1) {
					if (tmp_board[item+1]==0) {
						if(returned_board[item+1]<=0) {
							tmp_board[item+1]=-1;
							path.AddLast(item+1);
						}
						else tmp_board[item+1]=-2;
					}
				} 
				if (item%WIDTH!=0) {
					if (tmp_board[item-1]==0) {
						if(returned_board[item-1]<=0) {
							tmp_board[item-1]=-1;
							path.AddLast(item-1);
						}
						else tmp_board[item-1]=-2;
					}
				} 
				if (item/HEIGHT!=HEIGHT-1) {
					if (tmp_board[item+WIDTH]==0) {
						if(returned_board[item+WIDTH]<=0) {
							tmp_board[item+WIDTH]=-1;
							path.AddLast(item+WIDTH);
						}
						else tmp_board[item+WIDTH]=-2;
					}
				} 
				if (item/HEIGHT!=0) {
					if (tmp_board[item-WIDTH]==0) {
						if(returned_board[item-WIDTH]<=0) {
							tmp_board[item-WIDTH]=-1;
							path.AddLast(item-WIDTH);
						}
						else tmp_board[item-WIDTH]=-2;
					}
				} 
			}; //end_while
		}
		else tmp_board[seed_position]=-2;
	}; // end_if

};

List<PointToReturn> * MinMax::CloseCyclesOnBoard(int player, Board & returned_board,int  & red_count) {

	List<PointToReturn> * list_to_return=new List<PointToReturn>;
	Board tmp_board(WIDTH,HEIGHT);
	
// vyplnovaci strategie je takova, ze zasadim seminko vzdy jen na
// okraj hraciho pole, a po projeti celeho okraje mi zbude nevyplnena
// oblast, kterou jsem chtel puvodne vyplnit. Tudiz staci mi pak jen
// ziskat tyto body a to linearne.

// vyplnime oblast kolem seminka....

	for (int i=0; i<WIDTH; i++) 
	 	ExpandSeed(tmp_board,returned_board,i);
	for (i=0; i<HEIGHT; i++)
		ExpandSeed(tmp_board,returned_board,i*WIDTH);
	for (i=0; i<HEIGHT; i++)
		ExpandSeed(tmp_board,returned_board,i*WIDTH+WIDTH-1);
	for (i=(HEIGHT-1)*WIDTH; i<HEIGHT*WIDTH;i++)
		ExpandSeed(tmp_board,returned_board,i);
// a nyni nalezneme body, ktere jsou uvnitr oblasti.

	for (i=0; i<WIDTH*HEIGHT; i++) {
		if (tmp_board[i]==0) {
			PointToReturn * ptr = new PointToReturn(i,PlayBoard[i]);
			list_to_return->AddLast(*ptr);
// a rovnou vyplnime oblast
			if (player==0) {
				if (PlayBoard[i]>0) {
					PlayerRedCount--;
					PlayerBlueCount--;
					PlayerBlueCount-=BLUE_TAKES_RED_BONUS;
				}
				else if (PlayBoard[i]==0) {
						PlayerBlueCount--;
						PlayerBlueCount-=BLUE_TAKES_DEFAULT_BONUS;
				}

				PlayBoard[i]=-1;
			}
			else {
				if (PlayBoard[i]<0) {
// pocet uzavrenych bodu
					red_count++;

					PlayerRedCount++;
					PlayerBlueCount++;
					PlayerRedCount+=RED_TAKES_BLUE_BONUS;
				}
				else if (PlayBoard[i]==0) {
// pocet uzavrenych bodu
					red_count++;

					PlayerRedCount++;
					PlayerRedCount+=RED_TAKES_DEFAULT_BONUS;
//					PlayerBlueCount--;
				};

				PlayBoard[i]=1;
			}
		};
	};				

	return(list_to_return);
};

int MinMax::ChooseNextMove(int depth,int & maxdepth, int & best_value, int alpha, int beta) {

	List<int> * list_of_possible_moves;
	List<PointToReturn> * list_to_return;
	bool detected, detected_red, detected_blue;
	int tmp_best_move=0;
	int current_item=0;
	int player=depth%2;
	int returned_value;
	int tmp_best_value=(player == 0)?MAXINT:-MAXINT;
	
//Zkontrolujeme, jestli jeste muzeme pokracovat
	if (depth<maxdepth) {
		list_of_possible_moves = GetPossibleMoves(player);
		for (int i=0; i<list_of_possible_moves->GetCard(); i++) {
			detected=false;
			detected_blue=false;
			detected_red=false;
			int tmp_playerbluecount=PlayerBlueCount;
			int tmp_playerredcount=PlayerRedCount;
			current_item=(*list_of_possible_moves)[i];

			if (current_item==6&&depth==0) {
				cout<<"."<<endl;	
			};
// zde vytvorime docasnou hraci plochu a na ni vytvorime hranici.
// float z duvodu vicero cest, ukladane hodnoty totiz znamenaji:
// aaaab  ... a je vzdalenost od vychoziho bodu (current_item) a
//            b je cislo detekovaneho zacatku.. udava vlastne smer
// jak je vuci vyhozimu bodu dany zacatek orientovan.
			
			if (player == 0) {
				Board returned_board(WIDTH,HEIGHT);
				PlayerBlueCount--;
				if (DetectCycles(player,current_item, returned_board)) {
					int blue_count=0;
					detected=true;
					detected_blue=true;
					PlayBoard[current_item]=-depth-1;
					returned_board[current_item]=10;
					list_to_return=CloseCyclesOnBoard(player,returned_board,blue_count );
				}
				else PlayBoard[current_item]=-depth-1;

			}
			else {
				Board returned_board(WIDTH,HEIGHT);
				PlayerRedCount++;
				if (DetectCycles(player,current_item, returned_board)) {
					int red_count=0;
// ATTACK je zde z duvodu, ze nema smysl branit ctverci, ktery uzavira
//	jeden jediny bod hned odsameho zacatku.
					detected=true;
					detected_red=true;
					PlayBoard[current_item]=depth+1;
					returned_board[current_item]=10;
					list_to_return=CloseCyclesOnBoard(player,returned_board,red_count);
//					if (red_count==1&&!(depth==1||depth==0)) {
//						PlayerRedCount=0;
//					}
				}
				else PlayBoard[current_item]=depth+1;
			};

			if (detected_red) PlayerRedCount+=(MAXDEPTH-depth)*RED_FOUND_LEVEL_BONUS;
			else if (detected_blue) PlayerBlueCount-=(MAXDEPTH-depth)*BLUE_FOUND_LEVEL_BONUS;

			ChooseNextMove(depth+1, maxdepth, returned_value, alpha, beta);

			if ((player == 0) && (returned_value<tmp_best_value)) {
				tmp_best_move=current_item;
				tmp_best_value=returned_value;
			};
			if ((player == 1) && (returned_value>tmp_best_value)){
				tmp_best_move=current_item;
				tmp_best_value=returned_value;
			};

// zde je misto pro zotaveni se ze zmen ucinenych v rekurzi
// nejprve obnovime tah

			PlayBoard[current_item]=0;

// a dale obnovime vsechny body, ktere se po pridani bodu i uzavrely.
			if (detected) {
				for (int index=0; index<list_to_return->GetCard(); index++) {
					PlayBoard[(*list_to_return)[index].GetPosition()]=
							  (*list_to_return)[index].GetValue();
				};
				delete(list_to_return);
			}; // end_if detected
			PlayerBlueCount=tmp_playerbluecount;
			PlayerRedCount=tmp_playerredcount;
// ALPHA-BETA Algorithm, cut unnecessary trees
	       if (player==1) {
				if (returned_value<alpha) {
					//Alpha Cut
					break;
				}
		 	 	if (returned_value< beta) {
		 	 		beta = returned_value;
		 	 	}       	
			 }
			 else {
				if (returned_value>beta) {
					//Beta Cut
        			break;
				}
		 	 	if (returned_value> alpha) {
		 	 		alpha = returned_value;
		 	 	}       	
			 }
		};
	if (list_of_possible_moves->IsEmpty()) {

//	ohodnotime hraci pole;
		tmp_best_value=PlayerRedCount+PlayerBlueCount;
		if (player==0) tmp_best_value--;
	};
		delete(list_of_possible_moves);
	}
	else {

//	ohodnotime hraci pole;
		tmp_best_value=PlayerRedCount+PlayerBlueCount;
		if (maxdepth==MAXDEPTH)
			if (player==1) tmp_best_value--;
		else
			if (player==0) tmp_best_value--;

	};
	
	best_value=tmp_best_value;
	return(tmp_best_move);

};

// vrati seznam moznych pozic, na ktere muze hrat pocitac. V tomto
// pripade se jedna o okoli souperovych bodu.

List<int> * MinMax::GetPossibleMoves(const bool who_to_move) {

	List<int> * list_of_moves=new List<int>;
	bool temp_bool;

	for (int k=0; k<HEIGHT*WIDTH; k++) {
		if (PlayBoard[k]==0) {
			temp_bool=false;
			for (int i=-1; i<=1; i++) 
				for (int j=-1; j<=1; j++) {
					if ((((k % WIDTH) + i)>=0) &&
						(((k % WIDTH) + i)<=WIDTH-1) &&
						(((k / WIDTH)+ j)>=0) &&
						(((k / WIDTH)+ j)<=HEIGHT-1)) {

						if (who_to_move==true && PlayBoard[k+i+j*WIDTH]>0) 
							temp_bool=true;
						if (who_to_move==false && PlayBoard[k+i+j*WIDTH]<0) 
							temp_bool=true;
					};
				};
			if (temp_bool) list_of_moves->AddLast(k);
			temp_bool=false;
		};
	};
		
	return(list_of_moves);

};

MinMax::~MinMax() {

};
