/***************************************************************************
                          Minimax.h  -  description
                             -------------------
    begin                : Tue Feb 27 2001
    copyright            : (C) 2001 by kulich
    email                : xrotek@fi.muni.cz
 
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "List.h"
#include "Board.h"
#include <time.h>

#ifdef DEBUG
#undef DEBUG
#endif

extern Board PlayBoard;
extern int PlayerRedCount, PlayerBlueCount;

using namespace std;

const int MAXDEPTH=4;
const int MAXINT=10000; // pro nekonecno do algoritmu minimax - EvaluatePlayBoard
const int WIDTH=10;
const int HEIGHT=10;

// bonusy pro modreho;

const int BLUE_TAKES_RED_BONUS = 20;
const int BLUE_TAKES_DEFAULT_BONUS = 10;
const int BLUE_FOUND_LEVEL_BONUS=2;

// bonusy pro cerveneho

const int RED_TAKES_BLUE_BONUS = 20;
const int RED_TAKES_DEFAULT_BONUS = 10;
const int RED_FOUND_LEVEL_BONUS=5;

class PointToReturn {

	private:
		int position;
		int value;

	public:
		PointToReturn();
		PointToReturn(int position, int value);
		int GetPosition() { return(position); };
		int GetValue() { return(value); };
		~PointToReturn();

};

class MinMax {

	private:
	public:
		MinMax();
		List<int> * GetPossibleMoves(const bool who_to_move);
		bool DetectCycles(int player, int point, Board & returned_board);
		List<PointToReturn> * CloseCyclesOnBoard(int player, Board & returned_board, int & red_count);
		void ExpandSeed(Board & tmp_board,Board & returned_board, int seed);
		int ChooseNextMove(int depth, int & maxdepth, int & best_value, int alpha, int beta);
		~MinMax();
};